#ifndef _MCDAGGREGATE_H
#define _MCDAGGREGATE_H
/* -*- mode: C; -*- */

/*
   Copyright (c) 1997-2002 MathEngine PLC

   $Name:  $

   Date: $Date: 2003/05/05 00:57:07 $ - Revision: $Revision: 1.1 $

   This software and its accompanying manuals have been developed
   by MathEngine PLC ("MathEngine") and the copyright and all other
   intellectual property rights in them belong to MathEngine. All
   rights conferred by law (including rights under international
   copyright conventions) are reserved to MathEngine. This software
   may also incorporate information which is confidential to
   MathEngine.

   Save to the extent permitted by law, or as otherwise expressly
   permitted by MathEngine, this software and the manuals must not
   be copied (in whole or in part), re-arranged, altered or adapted
   in any way without the prior written consent of the Company. In
   addition, the information contained in the software may not be
   disseminated without the prior written consent of MathEngine.

 */


#include <MeMath.h>
#include <McdCTypes.h>
#include <McdGeometryTypes.h>
#include <McdGeometry.h>
#include <McdInteractionTable.h>

#ifdef __cplusplus
extern "C" {
#endif

MCD_DECLARE_GEOMETRY_TYPE(McdAggregate);


MEPUBLIC
McdAggregateID    MEAPI McdAggregateCreate(McdFramework *frame, 
                                           int maxChildren);

MEPUBLIC
McdAggregateID    MEAPI McdAggregateInit(McdAggregate *aggregate,
                                         McdFramework *frame, 
                                         int maxChildren);

MEPUBLIC
void              MEAPI McdAggregateTerm(McdAggregateID aggregate);

MEPUBLIC
void              MEAPI McdAggregateDestroy(McdAggregateID aggregate);

MEPUBLIC 
int               MEAPI McdAggregateAddElement(McdAggregateID aggregate, 
                                               McdGeometryID geometry, 
                                               MeMatrix4 relTM);

MEPUBLIC
void              MEAPI McdAggregateRemoveElement(McdAggregateID, int);
MEPUBLIC
void			  MEAPI McdAggregateCalculateBSphere(McdAggregateID g);
MEPUBLIC
int               MEAPI McdAggregateGetElementCount(McdAggregateID);
MEPUBLIC
int               MEAPI McdAggregateGetElementCountMax(McdAggregateID);
MEPUBLIC
McdGeometryID     MEAPI McdAggregateGetElementGeometry(McdAggregateID a, int i);
MEPUBLIC
MeMatrix4Ptr      MEAPI McdAggregateGetElementTransformPtr(McdAggregateID a,int i);
MEPUBLIC
MeBool            MEAPI McdAggregateGenericRegisterInteractions(McdFrameworkID frame);

MCD_DECLARE_LINESEG_INTERACTION(Aggregate);

MEPUBLIC
void              MEAPI McdAggregateRegisterInteractions(McdFrameworkID frame);

#ifdef __cplusplus
} 
#endif

#endif /* _MCDAGGREGATE_H */
