#ifndef _MCDCYLINDER_H
#define _MCDCYLINDER_H
/* -*- mode: C; -*- */

/*
   Copyright (c) 1997-2002 MathEngine PLC

   $Name:  $

   Date: $Date: 2003/05/05 00:57:07 $ - Revision: $Revision: 1.1 $

   This software and its accompanying manuals have been developed
   by MathEngine PLC ("MathEngine") and the copyright and all other
   intellectual property rights in them belong to MathEngine. All
   rights conferred by law (including rights under international
   copyright conventions) are reserved to MathEngine. This software
   may also incorporate information which is confidential to
   MathEngine.

   Save to the extent permitted by law, or as otherwise expressly
   permitted by MathEngine, this software and the manuals must not
   be copied (in whole or in part), re-arranged, altered or adapted
   in any way without the prior written consent of the Company. In
   addition, the information contained in the software may not be
   disseminated without the prior written consent of MathEngine.

 */


#include <McdGeometry.h>
#include <McdGeometryTypes.h>

#ifdef __cplusplus
extern "C" {
#endif


MCD_DECLARE_GEOMETRY_TYPE( McdCylinder );

MEPUBLIC
McdCylinderID     MEAPI McdCylinderCreate(McdFramework *frame,  MeReal r, MeReal h );

MEPUBLIC
McdCylinderID     MEAPI McdCylinderInit(McdCylinder *cylinder, McdFramework *frame, MeReal r, MeReal h);

MEPUBLIC
void              MEAPI McdCylinderTerm(McdCylinderID cylinder);

MEPUBLIC
void              MEAPI McdCylinderDestroy(McdCylinderID cylinder);

MEPUBLIC
void              MEAPI McdCylinderSetGeometricalParameters(McdCylinderID g,
                                                            MeReal inRadius, 
                                                            MeReal inHeight);
MEPUBLIC
void              MEAPI McdCylinderSetRadius( McdCylinderID g, MeReal r );

MEPUBLIC
void              MEAPI McdCylinderSetHeight( McdCylinderID g, MeReal h );

MEPUBLIC
MeReal            MEAPI McdCylinderGetRadius( McdCylinderID g );

MEPUBLIC
MeReal            MEAPI McdCylinderGetHeight( McdCylinderID g );

MEPUBLIC
MeReal            MEAPI McdCylinderGetHalfHeight( McdCylinderID g );

void              MEAPI McdCylinderGetXYAABB( McdGeometry* g, MeMatrix4 tm,
                            MeReal bounds[4]) ;

void              MEAPI McdCylinderMaximumPointLocal( McdGeometry *g,
                            MeReal * const inDir, MeReal * const outPoint);


#ifdef __cplusplus
}
#endif

#endif /* _MCDCYLINDER_H */
