#ifndef _MCDSPHYL_H
#define _MCDSPHYL_H
/* -*- mode: C; -*- */

/*
   Copyright (c) 1997-2002 MathEngine PLC

   $Name:  $

   Date: $Date: 2003/05/05 00:57:07 $ - Revision: $Revision: 1.1 $

   This software and its accompanying manuals have been developed
   by MathEngine PLC ("MathEngine") and the copyright and all other
   intellectual property rights in them belong to MathEngine. All
   rights conferred by law (including rights under international
   copyright conventions) are reserved to MathEngine. This software
   may also incorporate information which is confidential to
   MathEngine.

   Save to the extent permitted by law, or as otherwise expressly
   permitted by MathEngine, this software and the manuals must not
   be copied (in whole or in part), re-arranged, altered or adapted
   in any way without the prior written consent of the Company. In
   addition, the information contained in the software may not be
   disseminated without the prior written consent of MathEngine.

 */


#include <McdGeometry.h>
#include <McdGeometryTypes.h>
#include <McdInteractionTable.h>

#ifdef __cplusplus
extern "C" {
#endif


MCD_DECLARE_GEOMETRY_TYPE( McdSphyl );

MEPUBLIC
McdSphylID        MEAPI McdSphylCreate(McdFramework *frame,  MeReal r, MeReal h );

MEPUBLIC
McdSphylID        MEAPI McdSphylInit(McdSphyl *sphyl, McdFramework *frame, MeReal r, MeReal h);

MEPUBLIC
void              MEAPI McdSphylTerm(McdSphylID sphyl);

MEPUBLIC
void              MEAPI McdSphylDestroy(McdSphylID sphyl);

MEPUBLIC
void              MEAPI McdSphylSetRadius( McdSphylID s, MeReal r );
MEPUBLIC
MeReal            MEAPI McdSphylGetRadius( McdSphylID s );
MEPUBLIC
void              MEAPI McdSphylSetHeight( McdSphylID s, MeReal h );
MEPUBLIC
MeReal            MEAPI McdSphylGetHeight( McdSphylID s );


#ifdef __cplusplus
}
#endif

#endif /* _MCDSPHYL_H */
