#ifndef _MEASSETDBXMLIOTYPES__H
#define _MEASSETDBXMLIOTYPES__H

/* -*- mode: C; -*- */

/*
   Copyright (c) 1997-2002 MathEngine PLC

   $Name:  $

   Date: $Date: 2003/05/05 00:57:07 $ - Revision: $Revision: 1.1 $

   This software and its accompanying manuals have been developed
   by MathEngine PLC ("MathEngine") and the copyright and all other
   intellectual property rights in them belong to MathEngine. All
   rights conferred by law (including rights under international
   copyright conventions) are reserved to MathEngine. This software
   may also incorporate information which is confidential to
   MathEngine.

   Save to the extent permitted by law, or as otherwise expressly
   permitted by MathEngine, this software and the manuals must not
   be copied (in whole or in part), re-arranged, altered or adapted
   in any way without the prior written consent of the Company. In
   addition, the information contained in the software may not be
   disseminated without the prior written consent of MathEngine.

 */

/** @file
 * Types associated with MeAssetDBXMLIO.
 */

#include <MeXMLParser.h>
#include <MeXMLTree.h>
#include <MeXMLOutput.h>
#include <MeIDPool.h>

/*
 * NON FILE FORMAT VERSION SPECIFIC TYPES
 */
/** . */
typedef MeXMLError (MEAPI *MeFAssetHandler)(MeXMLElement *elem, PElement *parent);
/** . */
typedef MeFAsset* (MEAPI *MeFAssetCreateFromFile)(MeAssetDB *parent, MeIDPool *IDPool, PElement *e);
/** . */
typedef MeXMLElementID (MEAPI *MeFAssetWriteXML)(MeXMLOutput *op, MeFAsset *fa, MeXMLElementID parent);

/** . */
typedef struct MeAssetDBXMLInput     MeAssetDBXMLInput;
/** . */
typedef struct MeAssetDBXMLOutput    MeAssetDBXMLOutput;

/** . */
typedef enum
{
    kXMLInputErrorNone = 0,
    kXMLInputInvalidVersion,    /* version information in file was incorrect */
    kXMLInputParseError,        /* some problem during parsing */
    kXMLInputNewerVersion,      /* version of file format too new for loader */
    kXMLInputOlderVersion       /* file format is older than latest (not an error) */
} MeAssetDBXMLInputError;

/** . */
struct MeAssetDBXMLInput
{
    MeAssetDB              *db;
    MeIDPool               *IDPool;
    MeAssetDBXMLInputError  error;
    int                     majorVersion; /* major version of latest file loaded */
    int                     minorVersion; /* minor version of latest file loaded */
};

/** . */
struct MeAssetDBXMLOutput
{
    MeAssetDB       *db;
    char            *fileHeader;
};
#endif
